

/*  UNITS.H
    For use with TM40.C
    Stephen D. Anderson --- Aug. 2, 1994

    Table of HART Process Variable Units


    REVISION LOG:


*/

byte units[][12] =
{
    "Undefined",    /*  0   */
    "InH2O",        /*  1   */
    "InHg",         /*  2   */
    "FtH2O",        /*  3   */
    "mmH2O",        /*  4   */
    "mmHg",         /*  5   */
    "psi",          /*  6   */
    "bar",          /*  7   */
    "mbar",         /*  8   */
    "g/SqCm",       /*  9   */
    "kg/SqCm",      /*  10  */
    "PA",           /*  11  */
    "kPA",          /*  12  */
    "torr",         /*  13  */
    "ATM",          /*  14  */
    "CuFt/min",     /*  15  */
    "gal/min",      /*  16  */
    "l/min",        /*  17  */
    "ImpGal/min",   /*  18  */
    "CuMtr/hr",     /*  19  */
    "ft/s",         /*  20  */
    "mtr/s",        /*  21  */
    "gal/s",        /*  22  */
    "MilGal/day",   /*  23  */
    "l/s",          /*  24  */
    "MilL/day",     /*  25  */
    "CuFt/s",       /*  26  */
    "CuFt/day",     /*  27  */
    "CuMtr/s",      /*  28  */
    "CuMtr/day",    /*  29  */
    "ImpGal/hr",    /*  30  */
    "ImpGal/day",   /*  31  */
    "degC",         /*  32  */
    "degF",         /*  33  */
    "degR",         /*  34  */
    "Kelvin",       /*  35  */
    "mV",           /*  36  */
    "Ohm",          /*  37  */
    "Hz",           /*  38  */
    "mA",           /*  39  */
    "gal",          /*  40  */
    "liter",        /*  41  */
    "ImpGal",       /*  42  */
    "CuMtr",        /*  43  */
    "ft",           /*  44  */
    "meter",        /*  45  */
    "bbl",          /*  46  */
    "in",           /*  47  */
    "cm",           /*  48  */
    "mm",           /*  49  */
    "min",          /*  50  */
    "sec",          /*  51  */
    "hr",           /*  52  */
    "day",          /*  53  */
    "centistokes",  /*  54  */
    "cpoise",       /*  55  */
    "uSiemen",      /*  56  */
    "%",            /*  57  */
    "v",            /*  58  */
    "pH",           /*  59  */
    "gram",         /*  60  */
    "kg",           /*  61  */
    "MetTon",       /*  62  */
    "lb",           /*  63  */
    "ShTon",        /*  64  */
    "LTon",         /*  65  */
    "Undefined",    /*  66  */
    "Undefined",    /*  67  */
    "Undefined",    /*  68  */
    "Undefined",    /*  69  */
    "g/s",          /*  70  */
    "g/min",        /*  71  */
    "g/hr",         /*  72  */
    "kg/s",         /*  73  */
    "kg/min",       /*  74  */
    "kg/hr",        /*  75  */
    "kg/day",       /*  76  */
    "MetTon/min",   /*  77  */
    "MetTon/hr",    /*  78  */
    "MetTon/day",   /*  79  */
    "lb/s",         /*  80  */
    "lb/min",       /*  81  */
    "lb/hr",        /*  82  */
    "lb/day",       /*  83  */
    "ShTon/min",    /*  84  */
    "ShTon/hr",     /*  85  */
    "ShTon/day",    /*  86  */
    "Lton/hr",      /*  87  */
    "Lton/day",     /*  88  */
    "Undefined",    /*  89  */
    "SGU",          /*  90  */
    "g/CuCm",       /*  91  */
    "kg/CuMtr",     /*  92  */
    "lb/gal",       /*  93  */
    "lb/CuFt",      /*  94  */
    "g/ml",         /*  95  */
    "kg/l",         /*  96  */
    "g/l",          /*  97  */
    "lb/CuIn",      /*  98  */
    "ShTon/CuYd",   /*  99  */
    "degTwad",      /*  100 */
    "degBrix",      /*  101 */
    "degBaum hv",   /*  102 */
    "degBaum lt",   /*  103 */
    "degAPI",       /*  104 */
    "%sol-wt",      /*  105 */
    "%sol_vol",     /*  106 */
    "degBall",      /*  107 */
    "proof/vol",    /*  108 */
    "proof/mass",   /*  109 */
    "bush",         /*  110 */
    "CuYd",         /*  111 */
    "CuFt",         /*  112 */
    "CuIn",         /*  113 */
    "Undefined",    /*  114 */
    "Undefined",    /*  115 */
    "Undefined",    /*  116 */
    "Undefined",    /*  117 */
    "Undefined",    /*  118 */
    "Undefined",    /*  119 */
    "mtr/hr",       /*  120 */
    "Undefined",    /*  121 */
    "Undefined",    /*  122 */
    "Undefined",    /*  123 */
    "Undefined",    /*  124 */
    "Undefined",    /*  125 */
    "Undefined",    /*  126 */
    "Undefined",    /*  127 */
    "Undefined",    /*  128 */
    "Undefined",    /*  129 */
    "CuFt/hr",      /*  130 */
    "CuMtr/min",    /*  131 */
    "bbl/sec",      /*  132 */
    "bbl/min",      /*  133 */
    "bbl/hr",       /*  134 */
    "bbl/day",      /*  135 */
    "gal/hr",       /*  136 */
    "ImpGal/sec",   /*  137 */
    "l/hr",         /*  138 */
    "Undefined",    /*  139 */
    "Undefined",    /*  140 */
    "Undefined",    /*  141 */
    "Undefined",    /*  142 */
    "Undefined",    /*  143 */
    "Undefined",    /*  144 */
    "Undefined",    /*  145 */
    "Undefined",    /*  146 */
    "Undefined",    /*  147 */
    "Undefined",    /*  148 */
    "Undefined",    /*  149 */
    "% Stm Qual",   /*  150 */
    "Ft.In16",      /*  151 */
    "CuFt/lb",      /*  152 */
    "picofarad",    /*  153 */
    "Undefined",    /*  154 */
    "Undefined",    /*  155 */
    "Undefined",    /*  156 */
    "Undefined",    /*  157 */
    "Undefined",    /*  158 */
    "Undefined",    /*  159 */
    "% plato",      /*  160 */
    "Undefined",    /*  161 */
    "Undefined",    /*  162 */
    "Undefined",    /*  163 */
    "Undefined",    /*  164 */
    "Undefined",    /*  165 */
    "Undefined",    /*  166 */
    "Undefined",    /*  167 */
    "Undefined",    /*  168 */
    "Undefined",    /*  169 */
    "Undefined",    /*  170 */
    "Undefined",    /*  171 */
    "Undefined",    /*  172 */
    "Undefined",    /*  173 */
    "Undefined",    /*  174 */
    "Undefined",    /*  175 */
    "Undefined",    /*  176 */
    "Undefined",    /*  177 */
    "Undefined",    /*  178 */
    "Undefined",    /*  179 */
    "Undefined",    /*  180 */
    "Undefined",    /*  181 */
    "Undefined",    /*  182 */
    "Undefined",    /*  183 */
    "Undefined",    /*  184 */
    "Undefined",    /*  185 */
    "Undefined",    /*  186 */
    "Undefined",    /*  187 */
    "Undefined",    /*  188 */
    "Undefined",    /*  189 */
    "Undefined",    /*  190 */
    "Undefined",    /*  191 */
    "Undefined",    /*  192 */
    "Undefined",    /*  193 */
    "Undefined",    /*  194 */
    "Undefined",    /*  195 */
    "Undefined",    /*  196 */
    "Undefined",    /*  197 */
    "Undefined",    /*  198 */
    "Undefined",    /*  199 */
    "Undefined",    /*  200 */
    "Undefined",    /*  201 */
    "Undefined",    /*  202 */
    "Undefined",    /*  203 */
    "Undefined",    /*  204 */
    "Undefined",    /*  205 */
    "Undefined",    /*  206 */
    "Undefined",    /*  207 */
    "Undefined",    /*  208 */
    "Undefined",    /*  209 */
    "Undefined",    /*  210 */
    "Undefined",    /*  211 */
    "Undefined",    /*  212 */
    "Undefined",    /*  213 */
    "Undefined",    /*  214 */
    "Undefined",    /*  215 */
    "Undefined",    /*  216 */
    "Undefined",    /*  217 */
    "Undefined",    /*  218 */
    "Undefined",    /*  219 */
    "Undefined",    /*  220 */
    "Undefined",    /*  221 */
    "Undefined",    /*  222 */
    "Undefined",    /*  223 */
    "Undefined",    /*  224 */
    "Undefined",    /*  225 */
    "Undefined",    /*  226 */
    "Undefined",    /*  227 */
    "Undefined",    /*  228 */
    "Undefined",    /*  229 */
    "Undefined",    /*  230 */
    "Undefined",    /*  231 */
    "Undefined",    /*  232 */
    "Undefined",    /*  233 */
    "Undefined",    /*  234 */
    "gal/day",      /*  235 */
    "hectoliter",   /*  236 */
    "megapascal",   /*  237 */
    "InH20(4)",     /*  238 */
    "mmH20(4)",     /*  239 */
    "InH20(60)",    /*  240 */
    "Undefined",    /*  241 */
    "Undefined",    /*  242 */
    "Undefined",    /*  243 */
    "Undefined",    /*  244 */
    "Undefined",    /*  245 */
    "Undefined",    /*  246 */
    "Undefined",    /*  247 */
    "Undefined",    /*  248 */
    "Undefined",    /*  249 */
    "Undefined",    /*  250 */
    "Undefined",    /*  251 */
    "Undefined",    /*  252 */
    "Undefined",    /*  253 */
    "Undefined",    /*  254 */
    "Undefined"     /*  255 */
};

